#module
#const global ir3 0.577350
	ddim quaterniondf0,4
	ddim quaterniondf1,4
	ddim quaterniondf2,4
	ddim quaterniondf3,4
	ddim quater4,4
	ddim dffsvec0,3
	ddim dffsvec1,3
	ddim dfspec0,3
	ddim dfvec0,3
	ddim dfvec1,3
	ddim dfvec2,3
	ddim dfvec3,3
	ddim dfvec4,3
	ddim dfvec5,3
	ddim pixelhalf,3
	ddim c_diff,3
	ddim c_spec,3
	ddim specular_f,3
	ddim specular_brdf,3
	ddim dfnorm,3
	ddim df3dpos,3
	ddim dfbbox0,10
	dim dfscale,3
	dim dfrot,3
	dim dftrans,3
	dim dfobjinfo,8
	
#deffunc fpsinit
	second0@ = gettime(6)
	milliseconds0@ = gettime(7)
	return

#deffunc fpscalc
	second1@ = gettime(6)
	milliseconds1@ = gettime(7)
	if second1@ = second0@{
		dmilliseconds@ = milliseconds1@ - milliseconds0@
	}
	else{
		dmilliseconds@ = 1000 + milliseconds1@ - milliseconds0@
	}
	fps@ = 1000.0 / dmilliseconds@
	second0@ = second1@
	milliseconds0@ = milliseconds1@
	return

#deffunc vectorplus array pvecr,array pvec0,array pvec1
	pvecr.0 = pvec0.0 + pvec1.0
	pvecr.1 = pvec0.1 + pvec1.1
	pvecr.2 = pvec0.2 + pvec1.2
	return

#deffunc vectorminus array mvecr,array mvec0,array mvec1
	mvecr.0 = mvec0.0 - mvec1.0
	mvecr.1 = mvec0.1 - mvec1.1
	mvecr.2 = mvec0.2 - mvec1.2
	return

#defcfunc vectordot array dvec0,array dvec1
	return dvec0.0 * dvec1.0 + dvec0.1 * dvec1.1 + dvec0.2 * dvec1.2

#deffunc vectorcross array cvecr,array cvec0,array cvec1
	cvecr.0 = cvec0.1 * cvec1.2 - cvec0.2 * cvec1.1
	cvecr.1 = cvec0.2 * cvec1.0 - cvec0.0 * cvec1.2
	cvecr.2 = cvec0.0 * cvec1.1 - cvec0.1 * cvec1.0
	return

#deffunc vectorcrossnormalize array cvecr1,array cvec0b,array cvec1b
	cvecr1.0 = cvec0b.1 * cvec1b.2 - cvec0b.2 * cvec1b.1
	cvecr1.1 = cvec0b.2 * cvec1b.0 - cvec0b.0 * cvec1b.2
	cvecr1.2 = cvec0b.0 * cvec1b.1 - cvec0b.1 * cvec1b.0
	cvecr1length = sqrt(cvecr1.0 * cvecr1.0 + cvecr1.1 * cvecr1.1 + cvecr1.2 * cvecr1.2)
	cvecr1.0 /= cvecr1length
	cvecr1.1 /= cvecr1length
	cvecr1.2 /= cvecr1length
	return

#defcfunc vectorlength array lvec
	return sqrt(lvec.0 * lvec.0 + lvec.1 * lvec.1 + lvec.2 * lvec.2)

#deffunc vectornormalize array nvecr,array nvec0
	nveclength = sqrt(nvec0.0 * nvec0.0 + nvec0.1 * nvec0.1 + nvec0.2 * nvec0.2)
	nvecr.0 = nvec0.0 / nveclength
	nvecr.1 = nvec0.1 / nveclength
	nvecr.2 = nvec0.2 / nveclength
	return

#deffunc vectorminusnormalize array mnvecr,array mnvec0,array mnvec1
	vectorminus dfvec0,mnvec0,mnvec1
	vectornormalize mnvecr,dfvec0
	return

#deffunc vectormultiplyvector array bvecr,array bvec0,array bvec1
	bvecr.0 = bvec0.0 * bvec1.0
	bvecr.1 = bvec0.1 * bvec1.1
	bvecr.2 = bvec0.2 * bvec1.2
	return

#deffunc vectormultiplydbl array kvecr,double mutiplyk,array kvec0
	kvecr.0 = mutiplyk * kvec0.0
	kvecr.1 = mutiplyk * kvec0.1
	kvecr.2 = mutiplyk * kvec0.2
	return

#deffunc lerp3 array lerp3r,array lerp3a,array lerp3b,double lerp3s
	lerp3r.0 = lerp3a.0 + lerp3s * (lerp3b.0 - lerp3a.0)
	lerp3r.1 = lerp3a.1 + lerp3s * (lerp3b.1 - lerp3a.1)
	lerp3r.2 = lerp3a.2 + lerp3s * (lerp3b.2 - lerp3a.2)
	return

#deffunc cameraangleroundxz double degstep
	x = campos@.0 - camtargetpos@.0
	y = campos@.1 - camtargetpos@.1
	z = campos@.2 - camtargetpos@.2
	r0 = sqrt(x * x + z * z)
	theta0 = atan(z,x)
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	campos@.0 = camtargetpos@.0 + x
	campos@.2 = camtargetpos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraangleroundy double degstep
	x = campos@.0 - camtargetpos@.0
	y = campos@.1 - camtargetpos@.1
	z = campos@.2 - camtargetpos@.2
	r = sqrt(x * x + y * y + z * z)
	r0 = sqrt(x * x + z * z)
	theta = atan(y,r0)
	phi = atan(z,x)
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	theta += degstep
	;if theta >= 2.0 * M_PI : theta -= 2.0 * M_PI
	;r0 = r * cos(theta)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	campos@.0 = camtargetpos@.0 + x
	campos@.1 = camtargetpos@.1 + y
	campos@.2 = camtargetpos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameratargetroundxz double degstep
	x = camtargetpos@.0 - campos@.0
	y = camtargetpos@.1 - campos@.1
	z = camtargetpos@.2 - campos@.2
	
	r0 = sqrt(x * x + z * z)
	theta0 = atan(z,x)
	
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	camtargetpos@.0 = campos@.0 + x
	camtargetpos@.2 = campos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameratargetroundy double degstep
	x = camtargetpos@.0 - campos@.0
	y = camtargetpos@.1 - campos@.1
	z = camtargetpos@.2 - campos@.2
	
	r0 = sqrt(x * x + z * z)
	phi = atan(z,x)
	r = sqrt(x * x + y * y + z * z)
	theta = atan(y,r0)
	theta += degstep
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	camtargetpos@.0 = campos@.0 + x
	camtargetpos@.1 = campos@.1 + y
	camtargetpos@.2 = campos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameramovex double camerastep	
	campos@.0 += camerastep
	camtargetpos@.0 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return
	
#deffunc cameramovey double camerastep	
	campos@.1 += camerastep
	camtargetpos@.1 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameramovez double camerastep	
	campos@.2 += camerastep
	camtargetpos@.2 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraposforward  double camerastep
	vectorminus camvec@,camtargetpos@,campos@
	camveclength = vectorlength(camvec@)
	vectormultiplydbl tempvec@,camerastep / camveclength,camvec@
	campos@.0 += tempvec@.0
	campos@.1 += tempvec@.1
	campos@.2 += tempvec@.2
	camtargetpos@.0 += tempvec@.0
	camtargetpos@.1 += tempvec@.1
	camtargetpos@.2 += tempvec@.2

	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc camerascreenup double camerastep
	vectorminus dfvec0,camtargetpos@,campos@
	vectornormalize dfvec1,dfvec0
	dfvec2(0) = upvecx@
	dfvec2(1) = upvecy@
	dfvec2(2) = upvecz@
	vectorcrossnormalize dfvec0,dfvec2,dfvec1
	vectorcross dfvec2,dfvec1,dfvec0
	campos@.0 += dfvec2(0) * camerastep
	campos@.1 += dfvec2(1) * camerastep
	campos@.2 += dfvec2(2) * camerastep
	camtargetpos@.0 += dfvec2(0) * camerastep
	camtargetpos@.1 += dfvec2(1) * camerastep
	camtargetpos@.2 += dfvec2(2) * camerastep
	
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc camerascreenright double camerastep
	vectorminus dfvec0,camtargetpos@,campos@
	vectornormalize dfvec1,dfvec0
	dfvec2(0) = upvecx@
	dfvec2(1) = upvecy@
	dfvec2(2) = upvecz@
	vectorcrossnormalize dfvec0,dfvec2,dfvec1
	campos@.0 += dfvec0(0) * camerastep
	campos@.1 += dfvec0(1) * camerastep
	campos@.2 += dfvec0(2) * camerastep
	camtargetpos@.0 += dfvec0(0) * camerastep
	camtargetpos@.1 += dfvec0(1) * camerastep
	camtargetpos@.2 += dfvec0(2) * camerastep

	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraroundscx double degstep
	vectorminus dfvec0,camtargetpos@,campos@
	vectornormalize dfvec1,dfvec0
	dfvec2(0) = upvecx@
	dfvec2(1) = upvecy@
	dfvec2(2) = upvecz@
	vectorcrossnormalize dfvec3,dfvec2,dfvec1
	vectorcross dfvec2,dfvec1,dfvec3
	setquaternxyztheta quaterniondf3,dfvec2,degstep
	dfvec0(0) *= -1.0
	dfvec0(1) *= -1.0
	dfvec0(2) *= -1.0
	quaterniontransform quaterniondf3,dfvec0
	campos@.0 = camtargetpos@.0 + dfvec0(0)
	campos@.1 = camtargetpos@.1 + dfvec0(1)
	campos@.2 = camtargetpos@.2 + dfvec0(2)

	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraroundscy double degstep
	vectorminus dfvec0,camtargetpos@,campos@
	vectornormalize dfvec1,dfvec0
	dfvec2(0) = upvecx@
	dfvec2(1) = upvecy@
	dfvec2(2) = upvecz@
	vectorcrossnormalize dfvec3,dfvec2,dfvec1
	setquaternxyztheta quaterniondf3,dfvec3,degstep
	dfvec0(0) *= -1.0
	dfvec0(1) *= -1.0
	dfvec0(2) *= -1.0
	quaterniontransform quaterniondf3,dfvec0
	campos@.0 = camtargetpos@.0 + dfvec0(0)
	campos@.1 = camtargetpos@.1 + dfvec0(1)
	campos@.2 = camtargetpos@.2 + dfvec0(2)

	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return
#defcfunc dist2p double xd0,double yd0,double zd0,double xd1,double yd1,double zd1
	return sqrt((xd1 - xd0) * (xd1 - xd0) + (yd1 - yd0) * (yd1 - yd0) + (zd1 - zd0) * (zd1 - zd0))
	
#defcfunc dist2pxz double xd2,double zd2,double xd3,double zd3
	return sqrt((xd3 - xd2) * (xd3 - xd2) + (zd3 - zd2) * (zd3 - zd2))

#defcfunc myatan2 double xd4,double zd4
	if xd4 != 0.0{
		return atan(zd4,xd4)
	}
	else{
		if zd4 > 0.0 : return M_PI * 0.5 : else : return M_PI * -0.5
	}

#deffunc quaterniontransform array dfquater,array vtx0
	quaterniondf0.0 = -dfquater.0
	quaterniondf0.1 = -dfquater.1
	quaterniondf0.2 = -dfquater.2
	quaterniondf0.3 = dfquater.3

	quaterniondf1.0 = vtx0.0
	quaterniondf1.1 = vtx0.1
	quaterniondf1.2 = vtx0.2
	quaterniondf1.3 = 0.0
	
	quaternionmultiply quaterniondf2,quaterniondf1,quaterniondf0
	quaternionmultiply quaterniondf0,dfquater,quaterniondf2

	vtx0.0 = quaterniondf0.0
	vtx0.1 = quaterniondf0.1
	vtx0.2 = quaterniondf0.2
	return

#deffunc quaterniontransform1 array vtx2,array dfquater1,array vtx1
	quaterniondf0.0 = -dfquater1.0
	quaterniondf0.1 = -dfquater1.1
	quaterniondf0.2 = -dfquater1.2
	quaterniondf0.3 = dfquater1.3

	quaterniondf1.0 = vtx1.0
	quaterniondf1.1 = vtx1.1
	quaterniondf1.2 = vtx1.2
	quaterniondf1.3 = 0.0
	
	quaternionmultiply quaterniondf2,quaterniondf1,quaterniondf0
	quaternionmultiply quaterniondf0,dfquater1,quaterniondf2

	vtx2.0 = quaterniondf0.0
	vtx2.1 = quaterniondf0.1
	vtx2.2 = quaterniondf0.2
	return

#deffunc quaternionmultiply array rot4a,array rot4b,array rot4c
	rot4a.0 = rot4b.3 * rot4c.0 + rot4b.0 * rot4c.3 + rot4b.1 * rot4c.2 - rot4b.2 * rot4c.1
	rot4a.1 = rot4b.3 * rot4c.1 + rot4b.1 * rot4c.3 + rot4b.2 * rot4c.0 - rot4b.0 * rot4c.2
	rot4a.2 = rot4b.3 * rot4c.2 + rot4b.2 * rot4c.3 + rot4b.0 * rot4c.1 - rot4b.1 * rot4c.0
	rot4a.3 = rot4b.3 * rot4c.3 - rot4b.0 * rot4c.0 - rot4b.1 * rot4c.1 - rot4b.2 * rot4c.2
	return

#deffunc setquaternxyztheta array rot4d,array dfnvec,double dftheta
	rot4d.0 = dfnvec.0 * sin(0.5 * dftheta)
	rot4d.1 = dfnvec.1 * sin(0.5 * dftheta)
	rot4d.2 = dfnvec.2 * sin(0.5 * dftheta)
	rot4d.3 = cos(0.5 * dftheta)
	return

#deffunc posforwardxz array dfcpos,array dfcdir,int dfchara,double dfr
	dfcpos.0.dfchara += dfr * cos(-dfcdir.1.dfchara + 1.5 * M_PI)
	dfcpos.2.dfchara += dfr * sin(-dfcdir.1.dfchara + 1.5 * M_PI)
	;cfunc64v obj3dsclrottrsset,dfchara, varptr64(scale1@), varptr64(dfcdir.0.dfchara), varptr64(dfcpos.0.dfchara)
	return

#deffunc cubedataset double r1,int shade0
	vtxpos@ = -r1,r1,r1,r1,r1,r1,r1,r1,-r1,-r1,r1,-r1,-r1,r1,r1,-r1,r1,-r1,-r1,-r1,-r1,-r1,-r1,r1,-r1,r1,-r1,r1,r1,-r1,r1,-r1,-r1,-r1,-r1,-r1,r1,r1,-r1,r1,r1,r1,r1,-r1,r1,r1,-r1,-r1,r1,r1,r1,-r1,r1,r1,-r1,-r1,r1,r1,-r1,r1,-r1,-r1,-r1,r1,-r1,-r1,r1,-r1,r1,-r1,-r1,r1
	vtxtex@ = 0.25,0.0,0.5,0.0,0.5,0.25,0.25,0.25,0.0,0.25,0.25,0.25,0.25,0.5,0.0,0.5,0.25,0.25,0.5,0.25,0.5,0.5,0.25,0.5,0.5,0.25,0.75,0.25,0.75,0.5,0.5,0.5,0.75,0.25,1.0,0.25,1.0,0.5,0.75,0.5,0.25,0.5,0.5,0.5,0.5,0.75,0.25,0.75
	if shade0 = 0{
		vtxnorm@ = 0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0
	}
	else{
		vtxnorm@ = -ir3,ir3,ir3,ir3,ir3,ir3,ir3,ir3,-ir3,-ir3,ir3,-ir3,-ir3,ir3,ir3,-ir3,ir3,-ir3,-ir3,-ir3,-ir3,-ir3,-ir3,ir3,-ir3,ir3,-ir3,ir3,ir3,-ir3,ir3,-ir3,-ir3,-ir3,-ir3,-ir3,ir3,ir3,-ir3,ir3,ir3,ir3,ir3,-ir3,ir3,ir3,-ir3,-ir3,ir3,ir3,ir3,-ir3,ir3,ir3,-ir3,-ir3,ir3,ir3,-ir3,ir3,-ir3,-ir3,-ir3,ir3,-ir3,-ir3,ir3,-ir3,ir3,-ir3,-ir3,ir3
	}
	vtxuvec@ = 1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0
	vtxvvec@ = 0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,	0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,-1.0,0.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,1.0
	faceno@ = 0,1,3,3,1,2,4,5,7,7,5,6,8,9,11,11,9,10,12,13,15,15,13,14,16,17,19,19,17,18,20,21,23,23,21,22
	facenumdraw@ = 12
	vtxnumdraw@ = 24
	return

#deffunc calcnormal int width0
	repeat width0
		ycnt = cnt
		if ycnt = 0 : jm = width0 - 1 : else : jm = ycnt - 1
		if ycnt = width0 - 1 : jp = 0 : else : jp = ycnt + 1
		
		repeat width0 
			pos0height = peek(vrambump@,3 * (cnt + ycnt * width0))
			
			if cnt = 0 : im = width0 - 1 : else	: im = cnt - 1
			pos0heightxm = peek(vrambump@,3 * (im + ycnt * width0))
			
			if cnt = width0 - 1 : ip = 0 : else : ip = cnt + 1
			pos0heightxp = peek(vrambump@,3 * (ip + ycnt * width0))

			pos0heightym = peek(vrambump@,3 * (cnt + jm * width0))
			pos0heightyp = peek(vrambump@,3 * (cnt + jp * width0))

			dzdx(0) = 2.0
			dzdx(1) = 0.0
			dzdx(2) = double(pos0heightxp - pos0heightxm)
			dzdy(0) = 0.0
			dzdy(1) = 2.0
			dzdy(2) = double(pos0heightyp - pos0heightym)
			
			vectorcross normvec,dzdx,dzdy
			vectornormalize normvec0,normvec
			
			r0 = int(normvec0(0) * 128.0 + 127.5)
			g0 = int(normvec0(1) * 128.0 + 127.5)
			b0 = int(normvec0(2) * 128.0 + 127.5)
			
			poke vramnormal@,3 * (cnt + ycnt * width0),b0
			poke vramnormal@,3 * (cnt + ycnt * width0) + 1,g0
			poke vramnormal@,3 * (cnt + ycnt * width0) + 2,r0
			
		loop
	loop
	gsel 3
	redraw 1
	return

#deffunc zaratexmake int width1,int texno1
	buffer 2,width1,width1
	mref vrambump@,66
	randomize
	repeat width1 * width1
	b = rnd(7) * 10
	poke vrambump@,3 * cnt,b
	poke vrambump@,3 * cnt + 1,b
	poke vrambump@,3 * cnt + 2,b
	loop
	
	buffer 3,width1,width1
	mref vramnormal@,66
	calcnormal width1
	
	cfunc64v textransfer8888,texno1,varptr64(vramnormal@),width1
	return

#deffunc brickalbedoset
	buffer 4,w@,h@
	celdiv 4
	color brickcolor1r@,brickcolor1g@,brickcolor1b@
	boxf
	color brickcolor0r@,brickcolor0g@,brickcolor0b@
	boxf brickhaba@,brickhaba@,w@ - brickhaba@ - 1,h@ - brickhaba@ - 1
	gsel 5
	repeat brickdivtate@
	cnt0 = cnt
		repeat brickdivyoko@ + 1
		if cnt = 0{
			if cnt0 \ 2 = 0{
				pos 0,h@ * cnt0
			}
			else{
				pos -w@ / 2,h@ * cnt0
			}
		}
		celput 4
		loop
	loop
	cfunc64v textransfer8888,brickalbedo@,varptr64(vrambrick@),bricktexsize@
	cfunc64v obj3dtexchange,obj0@,0,0,brickalbedo@
	return

#deffunc brickmrset
	buffer 4,w@,h@
	celdiv 4
	color 10,250,0
	boxf
	color 1,150,0
	boxf brickhaba@,brickhaba@,w@ - brickhaba@ - 1,h@ - brickhaba@ - 1
	gsel 5
	repeat brickdivtate@
	cnt0 = cnt
		repeat brickdivyoko@ + 1
		if cnt = 0{
			if cnt0 \ 2 = 0{
				pos 0,h@ * cnt0
			}
			else{
				pos -w@ / 2,h@ * cnt0
			}
		}
		celput 4
		loop
	loop
	cfunc64v textransfer8888,brickmr@,varptr64(vrambrick@),bricktexsize@
	cfunc64v obj3dtexchange,obj0@,0,1,brickmr@
	return

#deffunc bricknormset
	buffer 4,w@,h@
	celdiv 4
	color 127,127,255
	boxf
	color 217,127,217
	boxf w@ - brickhaba@ - 1,brickhaba@,w@ - brickhaba@,h@ - brickhaba@ - 1
	color 37,127,217
	boxf brickhaba@ - 1,brickhaba@,brickhaba@,h@ - brickhaba@ - 1
	color 127,217,217
	boxf brickhaba@,brickhaba@ - 1,w@ - brickhaba@ - 1,brickhaba@
	color 127,37,217
	boxf brickhaba@,h@ - brickhaba@ - 1,w@ - brickhaba@ - 1,h@ - brickhaba@
	color 201,201,201
	pset w@ - brickhaba@ - 1,brickhaba@
	color 201,53,201
	pset w@ - brickhaba@ - 1,h@ - brickhaba@ - 1
	color 53,53,201
	pset brickhaba@,h@ - brickhaba@ - 1
	color 53,201,201
	pset brickhaba@,brickhaba@
	gsel 5
	repeat brickdivtate@
	cnt0 = cnt
		repeat brickdivyoko@ + 1
		if cnt = 0{
			if cnt0 \ 2 = 0{
				pos 0,h@ * cnt0
			}
			else{
				pos -w@ / 2,h@ * cnt0
			}
		}
		celput 4
		loop
	loop
	cfunc64v textransfer8888,bricknorm@,varptr64(vrambrick@),bricktexsize@
	cfunc64v obj3dtexchange,obj0@,0,2,bricknorm@
	return

#deffunc spheredataset double r2,int shade1,int ydiv0,int tdiv0
	dtheta = 2.0 * M_PI / ydiv0
	dphi = M_PI / tdiv0
	du2d = 1.0 / ydiv0
	dv2d = 1.0 / tdiv0
	
	repeat ydiv0
	cnt9 = 9 * cnt
	vtxpos@.cnt9 = 0.0
	vtxpos@.(cnt9 + 1) = r2
	vtxpos@.(cnt9 + 2) = 0.0
	vtxpos@.(cnt9 + 3) = r2 * sin(dphi) * cos(dtheta * double(cnt + 1))
	vtxpos@.(cnt9 + 4) = r2 * cos(dphi)
	vtxpos@.(cnt9 + 5) = r2 * sin(dphi) * sin(dtheta * double(cnt + 1))
	vtxpos@.(cnt9 + 6) = r2 * sin(dphi) * cos(dtheta * double(cnt))
	vtxpos@.(cnt9 + 7) = r2 * cos(dphi)
	vtxpos@.(cnt9 + 8) = r2 * sin(dphi) * sin(dtheta * double(cnt))

	cnt6 = 6 * cnt
	vtxtex@.cnt6 = du2d * (0.5 + double(cnt))
	vtxtex@.(cnt6 + 1) = 0.0
	vtxtex@.(cnt6 + 2) = du2d * double(cnt + 1)
	vtxtex@.(cnt6 + 3) = dv2d
	vtxtex@.(cnt6 + 4) = du2d * double(cnt)
	vtxtex@.(cnt6 + 5) = dv2d

	vtxnorm@.cnt9 = 0.0
	vtxnorm@.(cnt9 + 1) = 1.0
	vtxnorm@.(cnt9 + 2) = 0.0
	vtxnorm@.(cnt9 + 3) = sin(dphi) * cos(dtheta * double(cnt + 1))
	vtxnorm@.(cnt9 + 4) = cos(dphi)
	vtxnorm@.(cnt9 + 5) = sin(dphi) * sin(dtheta * double(cnt + 1))
	vtxnorm@.(cnt9 + 6) = sin(dphi) * cos(dtheta * double(cnt))
	vtxnorm@.(cnt9 + 7) = cos(dphi)
	vtxnorm@.(cnt9 + 8) = sin(dphi) * sin(dtheta * double(cnt))
	if shade1 = 0{
		dfx = vtxnorm@.cnt9 + vtxnorm@.(cnt9 + 3) + vtxnorm@.(cnt9 + 6)
		dfy = vtxnorm@.(cnt9 + 1) + vtxnorm@.(cnt9 + 4) + vtxnorm@.(cnt9 + 7)
		dfz = vtxnorm@.(cnt9 + 2) + vtxnorm@.(cnt9 + 5) + vtxnorm@.(cnt9 + 8)
		dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
		dfx /= dfl
		dfy /= dfl
		dfz /= dfl
		vtxnorm@.cnt9 = dfx
		vtxnorm@.(cnt9 + 1) = dfy
		vtxnorm@.(cnt9 + 2) = dfz
		vtxnorm@.(cnt9 + 3) = dfx
		vtxnorm@.(cnt9 + 4) = dfy
		vtxnorm@.(cnt9 + 5) = dfz
		vtxnorm@.(cnt9 + 6) = dfx
		vtxnorm@.(cnt9 + 7) = dfy
		vtxnorm@.(cnt9 + 8) = dfz
	}
	dfx = cos(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	dfz = sin(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	vtxuvec@.cnt9 = dfx
	vtxuvec@.(cnt9 + 1) = 0.0
	vtxuvec@.(cnt9 + 2) = dfz
	vtxuvec@.(cnt9 + 3) = dfx
	vtxuvec@.(cnt9 + 4) = 0.0
	vtxuvec@.(cnt9 + 5) = dfz
	vtxuvec@.(cnt9 + 6) = dfx
	vtxuvec@.(cnt9 + 7) = 0.0
	vtxuvec@.(cnt9 + 8) = dfz

	dfx = vtxpos@.(cnt9 + 3) + vtxpos@.(cnt9 + 6)
	dfy = vtxpos@.(cnt9 + 4) + vtxpos@.(cnt9 + 7) - 2.0 * vtxpos@.(cnt9 + 1)
	dfz = vtxpos@.(cnt9 + 5) + vtxpos@.(cnt9 + 8)
	dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
	dfx /= dfl
	dfy /= dfl
	dfz /= dfl
	vtxvvec@.cnt9 = dfx
	vtxvvec@.(cnt9 + 1) = dfy
	vtxvvec@.(cnt9 + 2) = dfz
	vtxvvec@.(cnt9 + 3) = dfx
	vtxvvec@.(cnt9 + 4) = dfy
	vtxvvec@.(cnt9 + 5) = dfz
	vtxvvec@.(cnt9 + 6) = dfx
	vtxvvec@.(cnt9 + 7) = dfy
	vtxvvec@.(cnt9 + 8) = dfz

	cnt3 = 3 * cnt
	faceno@.cnt3 = cnt3
	faceno@.(cnt3 + 1) = cnt3 + 1
	faceno@.(cnt3 + 2) = cnt3 + 2
	;logmes str(faceno@.cnt3) + ":" + str(faceno@.(cnt3 + 1)) + ":" + str(faceno@.(cnt3 + 2)) + ":"
	loop

	vtxnostartxyz = ydiv0 * 9
	vtxnostartuv = ydiv0 * 6
	idxstart = ydiv0 * 3
	idxstartvtxno = ydiv0 * 3
	;logmes "vtxnostartxyz = " + str(vtxnostartxyz) + " " + "vtxnostartuv = " + str(vtxnostartuv) + " " + "idxstart = " + str(idxstart) + " " + "idxstartvtxno = " + str(idxstartvtxno)
	repeat ydiv0 * (tdiv0 - 2)
	cnt12 = 12 * cnt + vtxnostartxyz
	jtate = cnt / ydiv0 + 1
	vtxpos@.cnt12 = r2 * sin(dphi * double(jtate)) * cos(dtheta * double(cnt))
	vtxpos@.(cnt12 + 1) = r2 * cos(dphi * double(jtate))
	vtxpos@.(cnt12 + 2) = r2 * sin(dphi * double(jtate)) * sin(dtheta * double(cnt))
	vtxpos@.(cnt12 + 3) = r2 * sin(dphi * double(jtate)) * cos(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 4) = r2 * cos(dphi * double(jtate))
	vtxpos@.(cnt12 + 5) = r2 * sin(dphi * double(jtate)) * sin(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 6) = r2 * sin(dphi * double(jtate + 1)) * cos(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 7) = r2 * cos(dphi * double(jtate + 1))
	vtxpos@.(cnt12 + 8) = r2 * sin(dphi * double(jtate + 1)) * sin(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 9) = r2 * sin(dphi * double(jtate + 1)) * cos(dtheta * double(cnt))
	vtxpos@.(cnt12 + 10) = r2 * cos(dphi * double(jtate + 1))
	vtxpos@.(cnt12 + 11) = r2 * sin(dphi * double(jtate + 1)) * sin(dtheta * double(cnt))

	jyoko = cnt \ ydiv0
	cnt8 = 8 * cnt + vtxnostartuv
	vtxtex@.cnt8 = du2d * double(jyoko)
	vtxtex@.(cnt8 + 1) = dv2d * double(jtate)
	vtxtex@.(cnt8 + 2) = du2d * double(jyoko + 1)
	vtxtex@.(cnt8 + 3) = dv2d * double(jtate)
	vtxtex@.(cnt8 + 4) = du2d * double(jyoko + 1)
	vtxtex@.(cnt8 + 5) = dv2d * double(jtate + 1)
	vtxtex@.(cnt8 + 6) = du2d * double(jyoko)
	vtxtex@.(cnt8 + 7) = dv2d * double(jtate + 1)

	vtxnorm@.cnt12 = r2 * sin(dphi * double(jtate)) * cos(dtheta * double(cnt))
	vtxnorm@.(cnt12 + 1) = r2 * cos(dphi * double(jtate))
	vtxnorm@.(cnt12 + 2) = r2 * sin(dphi * double(jtate)) * sin(dtheta * double(cnt))
	vtxnorm@.(cnt12 + 3) = r2 * sin(dphi * double(jtate)) * cos(dtheta * double(cnt + 1))
	vtxnorm@.(cnt12 + 4) = r2 * cos(dphi * double(jtate))
	vtxnorm@.(cnt12 + 5) = r2 * sin(dphi * double(jtate)) * sin(dtheta * double(cnt + 1))
	vtxnorm@.(cnt12 + 6) = r2 * sin(dphi * double(jtate + 1)) * cos(dtheta * double(cnt + 1))
	vtxnorm@.(cnt12 + 7) = r2 * cos(dphi * double(jtate + 1))
	vtxnorm@.(cnt12 + 8) = r2 * sin(dphi * double(jtate + 1)) * sin(dtheta * double(cnt + 1))
	vtxnorm@.(cnt12 + 9) = r2 * sin(dphi * double(jtate + 1)) * cos(dtheta * double(cnt))
	vtxnorm@.(cnt12 + 10) = r2 * cos(dphi * double(jtate + 1))
	vtxnorm@.(cnt12 + 11) = r2 * sin(dphi * double(jtate + 1)) * sin(dtheta * double(cnt))
	if shade1 = 0{
		dfx = vtxnorm@.cnt12 + vtxnorm@.(cnt12 + 3) + vtxnorm@.(cnt12 + 6) + vtxnorm@.(cnt12 + 9)
		dfy = vtxnorm@.(cnt12 + 1) + vtxnorm@.(cnt12 + 4) + vtxnorm@.(cnt12 + 7) + vtxnorm@.(cnt12 + 10)
		dfz = vtxnorm@.(cnt12 + 2) + vtxnorm@.(cnt12 + 5) + vtxnorm@.(cnt12 + 8) + vtxnorm@.(cnt12 + 11)
		dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
		dfx /= dfl
		dfy /= dfl
		dfz /= dfl
		vtxnorm@.cnt12 = dfx
		vtxnorm@.(cnt12 + 1) = dfy
		vtxnorm@.(cnt12 + 2) = dfz
		vtxnorm@.(cnt12 + 3) = dfx
		vtxnorm@.(cnt12 + 4) = dfy
		vtxnorm@.(cnt12 + 5) = dfz
		vtxnorm@.(cnt12 + 6) = dfx
		vtxnorm@.(cnt12 + 7) = dfy
		vtxnorm@.(cnt12 + 8) = dfz
		vtxnorm@.(cnt12 + 9) = dfx
		vtxnorm@.(cnt12 + 10) = dfy
		vtxnorm@.(cnt12 + 11) = dfz
	}
	dfx = cos(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	dfz = sin(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	vtxuvec@.cnt12 = dfx
	vtxuvec@.(cnt12 + 1) = 0.0
	vtxuvec@.(cnt12 + 2) = dfz
	vtxuvec@.(cnt12 + 3) = dfx
	vtxuvec@.(cnt12 + 4) = 0.0
	vtxuvec@.(cnt12 + 5) = dfz
	vtxuvec@.(cnt12 + 6) = dfx
	vtxuvec@.(cnt12 + 7) = 0.0
	vtxuvec@.(cnt12 + 8) = dfz
	vtxuvec@.(cnt12 + 9) = dfx
	vtxuvec@.(cnt12 + 10) = 0.0
	vtxuvec@.(cnt12 + 11) = dfz

	dfx0 = 0.5 * (vtxpos@.cnt12 + vtxpos@.(cnt12 + 3))
	dfy0 = vtxpos@.(cnt12 + 1)
	dfz0 = 0.5 * (vtxpos@.(cnt12 + 2) + vtxpos@.(cnt12 + 5))
	dfx1 = 0.5 * (vtxpos@.(cnt12 + 6) + vtxpos@.(cnt12 + 9))
	dfy1 = vtxpos@.(cnt12 + 7)
	dfz1 = 0.5 * (vtxpos@.(cnt12 + 8) + vtxpos@.(cnt12 + 11))
	dfx = dfx1 - dfx0
	dfy = dfy1 - dfy0
	dfz = dfz1 - dfz0
	dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
	dfx /= dfl
	dfy /= dfl
	dfz /= dfl
	vtxvvec@.cnt12 = dfx
	vtxvvec@.(cnt12 + 1) = dfy
	vtxvvec@.(cnt12 + 2) = dfz
	vtxvvec@.(cnt12 + 3) = dfx
	vtxvvec@.(cnt12 + 4) = dfy
	vtxvvec@.(cnt12 + 5) = dfz
	vtxvvec@.(cnt12 + 6) = dfx
	vtxvvec@.(cnt12 + 7) = dfy
	vtxvvec@.(cnt12 + 8) = dfz
	vtxvvec@.(cnt12 + 9) = dfx
	vtxvvec@.(cnt12 + 10) = dfy
	vtxvvec@.(cnt12 + 11) = dfz

	cnt6 = 6 * cnt + idxstart
	cntvtxidx = cnt * 4 + idxstartvtxno
	faceno@.cnt6 = cntvtxidx
	faceno@.(cnt6 + 1) = cntvtxidx + 1
	faceno@.(cnt6 + 2) = cntvtxidx + 3
	faceno@.(cnt6 + 3) = cntvtxidx + 3
	faceno@.(cnt6 + 4) = cntvtxidx + 1
	faceno@.(cnt6 + 5) = cntvtxidx + 2
	;logmes str(faceno@.cnt6) + ":" + str(faceno@.(cnt6 + 1)) + ":" + str(faceno@.(cnt6 + 2)) + ":" + str(faceno@.(cnt6 + 3)) + ":" + str(faceno@.(cnt6 + 4)) + ":" + str(faceno@.(cnt6 + 5)) + ":"
	loop

	vtxnostartxyz += ydiv0 * (tdiv0 - 2) * 12
	vtxnostartuv += ydiv0 * (tdiv0 - 2) * 8
	idxstart += ydiv0 * (tdiv0 - 2) * 6
	idxstartvtxno += ydiv0 * (tdiv0 - 2) * 4
	;logmes "vtxnostartxyz = " + str(vtxnostartxyz) + " " + "vtxnostartuv = " + str(vtxnostartuv) + " " + "idxstart = " + str(idxstart) + " " + "idxstartvtxno = " + str(idxstartvtxno)
	
	repeat ydiv0
	cnt9 = 9 * cnt + vtxnostartxyz
	vtxpos@.cnt9 = 0.0
	vtxpos@.(cnt9 + 1) = -r2
	vtxpos@.(cnt9 + 2) = 0.0
	vtxpos@.(cnt9 + 3) = r2 * sin(M_PI - dphi) * cos(dtheta * double(cnt))
	vtxpos@.(cnt9 + 4) = r2 * cos(M_PI - dphi)
	vtxpos@.(cnt9 + 5) = r2 * sin(M_PI - dphi) * sin(dtheta * double(cnt))
	vtxpos@.(cnt9 + 6) = r2 * sin(M_PI - dphi) * cos(dtheta * double(cnt + 1))
	vtxpos@.(cnt9 + 7) = r2 * cos(M_PI - dphi)
	vtxpos@.(cnt9 + 8) = r2 * sin(M_PI - dphi) * sin(dtheta * double(cnt + 1))

	cnt6 = 6 * cnt + vtxnostartxyz
	vtxtex@.cnt6 = du2d * (0.5 + double(cnt))
	vtxtex@.(cnt6 + 1) = 1.0
	vtxtex@.(cnt6 + 2) = du2d * double(cnt)
	vtxtex@.(cnt6 + 3) = 1.0 - dv2d
	vtxtex@.(cnt6 + 4) = du2d * double(cnt + 1)
	vtxtex@.(cnt6 + 5) = 1.0 - dv2d

	vtxnorm@.cnt9 = 0.0
	vtxnorm@.(cnt9 + 1) = -1.0
	vtxnorm@.(cnt9 + 2) = 0.0
	vtxnorm@.(cnt9 + 3) = sin(M_PI - dphi) * cos(dtheta * double(cnt))
	vtxnorm@.(cnt9 + 4) = cos(M_PI - dphi)
	vtxnorm@.(cnt9 + 5) = sin(M_PI - dphi) * sin(dtheta * double(cnt))
	vtxnorm@.(cnt9 + 6) = sin(M_PI - dphi) * cos(dtheta * double(cnt + 1))
	vtxnorm@.(cnt9 + 7) = cos(M_PI - dphi)
	vtxnorm@.(cnt9 + 8) = sin(M_PI - dphi) * sin(dtheta * double(cnt + 1))
	if shade1 = 0{
		dfx = vtxnorm@.cnt9 + vtxnorm@.(cnt9 + 3) + vtxnorm@.(cnt9 + 6)
		dfy = vtxnorm@.(cnt9 + 1) + vtxnorm@.(cnt9 + 4) + vtxnorm@.(cnt9 + 7)
		dfz = vtxnorm@.(cnt9 + 2) + vtxnorm@.(cnt9 + 5) + vtxnorm@.(cnt9 + 8)
		dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
		dfx /= dfl
		dfy /= dfl
		dfz /= dfl
		vtxnorm@.cnt9 = dfx
		vtxnorm@.(cnt9 + 1) = dfy
		vtxnorm@.(cnt9 + 2) = dfz
		vtxnorm@.(cnt9 + 3) = dfx
		vtxnorm@.(cnt9 + 4) = dfy
		vtxnorm@.(cnt9 + 5) = dfz
		vtxnorm@.(cnt9 + 6) = dfx
		vtxnorm@.(cnt9 + 7) = dfy
		vtxnorm@.(cnt9 + 8) = dfz
	}
	dfx = cos(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	dfz = sin(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	vtxuvec@.cnt9 = dfx
	vtxuvec@.(cnt9 + 1) = 0.0
	vtxuvec@.(cnt9 + 2) = dfz
	vtxuvec@.(cnt9 + 3) = dfx
	vtxuvec@.(cnt9 + 4) = 0.0
	vtxuvec@.(cnt9 + 5) = dfz
	vtxuvec@.(cnt9 + 6) = dfx
	vtxuvec@.(cnt9 + 7) = 0.0
	vtxuvec@.(cnt9 + 8) = dfz

	dfx = -vtxpos@.(cnt9 + 3) - vtxpos@.(cnt9 + 6)
	dfy = -vtxpos@.(cnt9 + 4) - vtxpos@.(cnt9 + 7) + 2.0 * vtxpos@.(cnt9 + 1)
	dfz = -vtxpos@.(cnt9 + 5) - vtxpos@.(cnt9 + 8)
	dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
	dfx /= dfl
	dfy /= dfl
	dfz /= dfl
	vtxvvec@.cnt9 = dfx
	vtxvvec@.(cnt9 + 1) = dfy
	vtxvvec@.(cnt9 + 2) = dfz
	vtxvvec@.(cnt9 + 3) = dfx
	vtxvvec@.(cnt9 + 4) = dfy
	vtxvvec@.(cnt9 + 5) = dfz
	vtxvvec@.(cnt9 + 6) = dfx
	vtxvvec@.(cnt9 + 7) = dfy
	vtxvvec@.(cnt9 + 8) = dfz

	cnt3 = 3 * cnt + idxstart
	cntvtxidx = cnt * 3 + idxstartvtxno
	faceno@.cnt3 = cntvtxidx
	faceno@.(cnt3 + 1) = cntvtxidx + 1
	faceno@.(cnt3 + 2) = cntvtxidx + 2
	;logmes str(faceno@.cnt3) + ":" + str(faceno@.(cnt3 + 1)) + ":" + str(faceno@.(cnt3 + 2)) + ":"
	loop
	
	facenumdraw@ = 2 * ydiv0 + ydiv0 * (tdiv0 - 2) * 2
	vtxnumdraw@ = 2 * ydiv0 * 3 + ydiv0 * (tdiv0 - 2) * 4
	return

#deffunc cylinderdataset double r3,int shade2,int ydiv1,double r4
	dtheta = 2.0 * M_PI / ydiv1
	repeat ydiv1
	cnt3 = cnt * 3
	vtxpos@.cnt3 = r4 * cos(-dtheta * double(cnt))
	vtxpos@.(cnt3 + 1) = r3
	vtxpos@.(cnt3 + 2) = r4 * sin(-dtheta * double(cnt))
	
	vtxtex@.(cnt * 2 ) = 0.25 + 0.25 * cos(-dtheta * double(cnt))
	vtxtex@.(cnt * 2 + 1) = 0.75 + 0.25 * sin(-dtheta * double(cnt))

	if shade2 = 0{
		vtxnorm@.cnt3 = 0.0
		vtxnorm@.(cnt3 + 1) = 1.0
		vtxnorm@.(cnt3 + 2) = 0.0
	}
	else{
		dfx = 0.5 * M_PI * (cos(-dtheta * double(cnt) - 0.5 * dtheta) + cos(-dtheta * double(cnt) + 0.5 * dtheta))
		dfy = M_PI - dtheta
		dfz = 0.5 * M_PI * (sin(-dtheta * double(cnt) - 0.5 * dtheta) + sin(-dtheta * double(cnt) + 0.5 * dtheta))
		dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
		dfx /= dfl
		dfy /= dfl
		dfz /= dfl
		vtxnorm@.cnt3 = dfx
		vtxnorm@.(cnt3 + 1) = dfy
		vtxnorm@.(cnt3 + 2) = dfz
		if cnt = 0 : dfvec1 = 0.0,1.0,0.0 : dfvec2 = dfx,dfy,dfz
	}
	vtxuvec@.cnt3 = 1.0
	vtxuvec@.(cnt3 + 1) = 0.0
	vtxuvec@.(cnt3 + 2) = 0.0

	vtxvvec@.cnt3 = 0.0
	vtxvvec@.(cnt3 + 1) = 0.0
	vtxvvec@.(cnt3 + 2) = -1.0
	loop

	repeat ydiv1 - 2
	cnt3 = cnt * 3
	faceno@.cnt3 = 0
	faceno@.(cnt3 + 1) = cnt + 1
	faceno@.(cnt3 + 2) = cnt + 2
	loop

	vtxnostartxyz = ydiv1 * 3
	vtxnostartuv = ydiv1 * 2
	idxstart = (ydiv1 - 2) * 3
	idxstartvtxno = ydiv1
	du2d = 1.0 / ydiv1
	repeat ydiv1
	cnt12 = 12 * cnt + vtxnostartxyz
	vtxpos@.cnt12 = r4 * cos(dtheta * double(cnt))
	vtxpos@.(cnt12 + 1) = r3
	vtxpos@.(cnt12 + 2) = r4 * sin(dtheta * double(cnt))
	vtxpos@.(cnt12 + 3) = r4 * cos(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 4) = r3
	vtxpos@.(cnt12 + 5) = r4 * sin(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 6) = r4 * cos(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 7) = -r3
	vtxpos@.(cnt12 + 8) = r4 * sin(dtheta * double(cnt + 1))
	vtxpos@.(cnt12 + 9) = r4 * cos(dtheta * double(cnt))
	vtxpos@.(cnt12 + 10) = -r3
	vtxpos@.(cnt12 + 11) = r4 * sin(dtheta * double(cnt))

	cnt8 = 8 * cnt + vtxnostartuv
	vtxtex@.cnt8 = du2d * double(cnt)
	vtxtex@.(cnt8 + 1) = 0.0
	vtxtex@.(cnt8 + 2) = du2d * double(cnt + 1)
	vtxtex@.(cnt8 + 3) = 0.0
	vtxtex@.(cnt8 + 4) = du2d * double(cnt + 1)
	vtxtex@.(cnt8 + 5) = 0.5
	vtxtex@.(cnt8 + 6) = du2d * double(cnt)
	vtxtex@.(cnt8 + 7) = 0.5

	if shade2 = 0{
		dfx = cos(M_PI / ydiv1 + double(cnt) * dtheta)
		dfz = sin(M_PI / ydiv1 + double(cnt) * dtheta)
		vtxnorm@.cnt12 = dfx
		vtxnorm@.(cnt12 + 1) = 0.0
		vtxnorm@.(cnt12 + 2) = dfz
		vtxnorm@.(cnt12 + 3) = dfx
		vtxnorm@.(cnt12 + 4) = 0.0
		vtxnorm@.(cnt12 + 5) = dfz
		vtxnorm@.(cnt12 + 6) = dfx
		vtxnorm@.(cnt12 + 7) = 0.0
		vtxnorm@.(cnt12 + 8) = dfz
		vtxnorm@.(cnt12 + 9) = dfx
		vtxnorm@.(cnt12 + 10) = 0.0
		vtxnorm@.(cnt12 + 11) = dfz
	}
	else{
		setquaternxyztheta quater4,dfvec1,-dtheta * double(cnt)
		quaterniontransform1 dfvec3,quater4,dfvec2
		setquaternxyztheta quater4,dfvec1,-dtheta * double(cnt + 1)
		quaterniontransform1 dfvec4,quater4,dfvec2
		vtxnorm@.cnt12 = dfvec3(0)
		vtxnorm@.(cnt12 + 1) = dfvec3(1)
		vtxnorm@.(cnt12 + 2) = dfvec3(2)
		vtxnorm@.(cnt12 + 3) = dfvec4(0)
		vtxnorm@.(cnt12 + 4) = dfvec4(1)
		vtxnorm@.(cnt12 + 5) = dfvec4(2)
		vtxnorm@.(cnt12 + 6) = dfvec4(0)
		vtxnorm@.(cnt12 + 7) = -dfvec4(1)
		vtxnorm@.(cnt12 + 8) = dfvec4(2)
		vtxnorm@.(cnt12 + 9) = dfvec3(0)
		vtxnorm@.(cnt12 + 10) = -dfvec3(1)
		vtxnorm@.(cnt12 + 11) = dfvec3(2)
	}
	dfx = cos(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	dfz = sin(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	vtxuvec@.cnt12 = dfx
	vtxuvec@.(cnt12 + 1) = 0.0
	vtxuvec@.(cnt12 + 2) = dfz
	vtxuvec@.(cnt12 + 3) = dfx
	vtxuvec@.(cnt12 + 4) = 0.0
	vtxuvec@.(cnt12 + 5) = dfz
	vtxuvec@.(cnt12 + 6) = dfx
	vtxuvec@.(cnt12 + 7) = 0.0
	vtxuvec@.(cnt12 + 8) = dfz
	vtxuvec@.(cnt12 + 9) = dfx
	vtxuvec@.(cnt12 + 10) = 0.0
	vtxuvec@.(cnt12 + 11) = dfz

	vtxvvec@.cnt12 = 0.0
	vtxvvec@.(cnt12 + 1) = -1.0
	vtxvvec@.(cnt12 + 2) = 0.0
	vtxvvec@.(cnt12 + 3) = 0.0
	vtxvvec@.(cnt12 + 4) = -1.0
	vtxvvec@.(cnt12 + 5) = 0.0
	vtxvvec@.(cnt12 + 6) = 0.0
	vtxvvec@.(cnt12 + 7) = -1.0
	vtxvvec@.(cnt12 + 8) = 0.0
	vtxvvec@.(cnt12 + 9) = 0.0
	vtxvvec@.(cnt12 + 10) = -1.0
	vtxvvec@.(cnt12 + 11) = 0.0

	cnt6 = 6 * cnt + idxstart
	cntvtxidx = cnt * 4 + idxstartvtxno
	faceno@.cnt6 = cntvtxidx
	faceno@.(cnt6 + 1) = cntvtxidx + 1
	faceno@.(cnt6 + 2) = cntvtxidx + 3
	faceno@.(cnt6 + 3) = cntvtxidx + 3
	faceno@.(cnt6 + 4) = cntvtxidx + 1
	faceno@.(cnt6 + 5) = cntvtxidx + 2
	loop

	vtxnostartxyz += ydiv1 * 12
	vtxnostartuv += ydiv1 * 8
	idxstart += ydiv1 * 6
	idxstartvtxno += ydiv1 * 4

	repeat ydiv1
	cnt3 = cnt * 3 + vtxnostartxyz
	vtxpos@.cnt3 = r4 * cos(dtheta * double(cnt))
	vtxpos@.(cnt3 + 1) = -r3
	vtxpos@.(cnt3 + 2) = r4 * sin(dtheta * double(cnt))
	
	vtxtex@.(cnt * 2 + vtxnostartuv) = 0.75 + 0.25 * cos(-dtheta * double(cnt))
	vtxtex@.(cnt * 2 + 1 + vtxnostartuv) = 0.75 + 0.25 * sin(-dtheta * double(cnt))

	if shade2 = 0{
		vtxnorm@.cnt3 = 0.0
		vtxnorm@.(cnt3 + 1) = -1.0
		vtxnorm@.(cnt3 + 2) = 0.0
	}
	else{
		dfvec2(1) *= -1.0
		setquaternxyztheta quater4,dfvec1,-dtheta * double(cnt)
		quaterniontransform1 dfvec3,quater4,dfvec2
		vtxnorm@.cnt3 = dfvec3(0)
		vtxnorm@.(cnt3 + 1) = dfvec3(1)
		vtxnorm@.(cnt3 + 2) = dfvec3(2)
	}
	vtxuvec@.cnt3 = 1.0
	vtxuvec@.(cnt3 + 1) = 0.0
	vtxuvec@.(cnt3 + 2) = 0.0

	vtxvvec@.cnt3 = 0.0
	vtxvvec@.(cnt3 + 1) = 0.0
	vtxvvec@.(cnt3 + 2) = 1.0
	loop

	repeat ydiv1 - 2
	cnt3 = cnt * 3 + idxstart
	faceno@.cnt3 = idxstartvtxno
	faceno@.(cnt3 + 1) = cnt + 1 + idxstartvtxno
	faceno@.(cnt3 + 2) = cnt + 2 + idxstartvtxno
	loop

	facenumdraw@ = (ydiv1 - 2) * 2 + ydiv1 * 2
	vtxnumdraw@ = ydiv1 * 2 + ydiv1 * 4
	return

#deffunc conedataset double r5,int shade3,int ydiv2,double r6
	dtheta = 2.0 * M_PI / ydiv2
	du2d = 1.0 / ydiv2
	repeat ydiv2
	cnt9 = 9 * cnt
	vtxpos@.cnt9 = 0.0
	vtxpos@.(cnt9 + 1) = r5
	vtxpos@.(cnt9 + 2) = 0.0
	vtxpos@.(cnt9 + 3) = r6 * cos(dtheta * double(cnt + 1))
	vtxpos@.(cnt9 + 4) = -r5
	vtxpos@.(cnt9 + 5) = r6 * sin(dtheta * double(cnt + 1))
	vtxpos@.(cnt9 + 6) = r6 * cos(dtheta * double(cnt))
	vtxpos@.(cnt9 + 7) = -r5
	vtxpos@.(cnt9 + 8) = r6 * sin(dtheta * double(cnt))

	cnt6 = 6 * cnt
	vtxtex@.cnt6 = du2d * (0.5 + double(cnt))
	vtxtex@.(cnt6 + 1) = 1.0
	vtxtex@.(cnt6 + 2) = du2d * double(cnt + 1)
	vtxtex@.(cnt6 + 3) = 0.5
	vtxtex@.(cnt6 + 4) = du2d * double(cnt)
	vtxtex@.(cnt6 + 5) = 0.5

	dfvec1 = r6 * cos(dtheta * double(cnt + 1)),-2.0 * r5,r6 * sin(dtheta * double(cnt + 1))
	dfvec2 = r6 * cos(dtheta * double(cnt)),-2.0 * r5,r6 * sin(dtheta * double(cnt))
	vectorcrossnormalize dfvec3,dfvec1,dfvec2
	vtxnorm@.cnt9 = dfvec3(0)
	vtxnorm@.(cnt9 + 1) = dfvec3(1)
	vtxnorm@.(cnt9 + 2) = dfvec3(2)
	vtxnorm@.(cnt9 + 3) = dfvec3(0)
	vtxnorm@.(cnt9 + 4) = dfvec3(1)
	vtxnorm@.(cnt9 + 5) = dfvec3(2)
	vtxnorm@.(cnt9 + 6) = dfvec3(0)
	vtxnorm@.(cnt9 + 7) = dfvec3(1)
	vtxnorm@.(cnt9 + 8) = dfvec3(2)
	if cnt = 0{
		dfvec4(0) = 0.5 * dfvec1(0) + 0.5 * dfvec2(0)
		dfvec4(1) = 0.5 * dfvec1(1) + 0.5 * dfvec2(1)
		dfvec4(2) = 0.5 * dfvec1(2) + 0.5 * dfvec2(2)
		dfl0 = vectorlength(dfvec4)
		dfvec4(0) = r6 * cos(dtheta * double(cnt + 1)) - r6 * cos(dtheta * double(cnt))
		dfvec4(1) = 0.0
		dfvec4(2) = r6 * sin(dtheta * double(cnt + 1)) - r6 * sin(dtheta * double(cnt))
		dfl1 = vectorlength(dfvec4)
		dfangle0 = atan(dfl0,dfl1)
		dfvec4(0) = dfvec3(0)
		dfvec4(1) = dfvec3(1)
		dfvec4(2) = dfvec3(2)
	}
	if cnt = ydiv2 - 1  : dfvec5(0) = dfvec3(0) : dfvec5(1) = dfvec3(1) : dfvec5(2) = dfvec3(2)
	
	dfx = cos(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	dfz = sin(0.5 * M_PI + (0.5 + double(cnt)) * dtheta)
	vtxuvec@.cnt9 = dfx
	vtxuvec@.(cnt9 + 1) = 0.0
	vtxuvec@.(cnt9 + 2) = dfz
	vtxuvec@.(cnt9 + 3) = dfx
	vtxuvec@.(cnt9 + 4) = 0.0
	vtxuvec@.(cnt9 + 5) = dfz
	vtxuvec@.(cnt9 + 6) = dfx
	vtxuvec@.(cnt9 + 7) = 0.0
	vtxuvec@.(cnt9 + 8) = dfz

	dfx = 0.5 * (r6 * cos(dtheta * double(cnt)) + r6 * cos(dtheta * double(cnt + 1)))
	dfy = -2.0 * r5
	dfz = 0.5 * (r6 * sin(dtheta * double(cnt)) + r6 * sin(dtheta * double(cnt + 1)))
	dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
	dfx /= dfl
	dfy /= dfl
	dfz /= dfl
	vtxvvec@.cnt9 = dfx
	vtxvvec@.(cnt9 + 1) = dfy
	vtxvvec@.(cnt9 + 2) = dfz
	vtxvvec@.(cnt9 + 3) = dfx
	vtxvvec@.(cnt9 + 4) = dfy
	vtxvvec@.(cnt9 + 5) = dfz
	vtxvvec@.(cnt9 + 6) = dfx
	vtxvvec@.(cnt9 + 7) = dfy
	vtxvvec@.(cnt9 + 8) = dfz

	cnt3 = 3 * cnt
	faceno@.cnt3 = cnt3
	faceno@.(cnt3 + 1) = cnt3 + 1
	faceno@.(cnt3 + 2) = cnt3 + 2
	loop

	if shade3 = 1{
		dfvec1(0) = dfangle0 * dfvec4(0) + dfangle0 * dfvec5(0)
		dfvec1(1) = dfangle0 * dfvec4(1) + dfangle0 * dfvec5(1) - M_PI + dtheta
		dfvec1(2) = dfangle0 * dfvec4(2) + dfangle0 * dfvec5(2)
		vectornormalize dfvec2,dfvec1
		dfvec1 = 0.0,1.0,0.0
		repeat ydiv2
		setquaternxyztheta quater4,dfvec1,-dtheta * double(cnt + 1)
		quaterniontransform1 dfvec3,quater4,dfvec2
		setquaternxyztheta quater4,dfvec1,-dtheta * double(cnt)
		quaterniontransform1 dfvec4,quater4,dfvec2
		cnt9 = 9 * cnt
		vtxnorm@.cnt9 = 0.0
		vtxnorm@.(cnt9 + 1) = 1.0
		vtxnorm@.(cnt9 + 2) = 0.0
		vtxnorm@.(cnt9 + 3) = dfvec3(0)
		vtxnorm@.(cnt9 + 4) = dfvec3(1)
		vtxnorm@.(cnt9 + 5) = dfvec3(2)
		vtxnorm@.(cnt9 + 6) = dfvec4(0)
		vtxnorm@.(cnt9 + 7) = dfvec4(1)
		vtxnorm@.(cnt9 + 8) = dfvec4(2)
		loop
	}
	vtxnostartxyz = ydiv2 * 9
	vtxnostartuv = ydiv2 * 6
	idxstart = ydiv2 * 3
	idxstartvtxno = ydiv2 * 3

	repeat ydiv2
	cnt3 = cnt * 3 + vtxnostartxyz
	vtxpos@.cnt3 = r6 * cos(dtheta * double(cnt))
	vtxpos@.(cnt3 + 1) = -r5
	vtxpos@.(cnt3 + 2) = r6 * sin(dtheta * double(cnt))
	
	vtxtex@.(cnt * 2 + vtxnostartuv) = 0.25 + 0.25 * cos(-dtheta * double(cnt))
	vtxtex@.(cnt * 2 + 1 + vtxnostartuv) = 0.75 + 0.25 * sin(-dtheta * double(cnt))

	if shade3 = 0{
		vtxnorm@.cnt3 = 0.0
		vtxnorm@.(cnt3 + 1) = -1.0
		vtxnorm@.(cnt3 + 2) = 0.0
	}
	else{
		setquaternxyztheta quater4,dfvec1,-dtheta * double(cnt)
		quaterniontransform1 dfvec3,quater4,dfvec2
		vtxnorm@.cnt3 = dfvec3(0)
		vtxnorm@.(cnt3 + 1) = dfvec3(1)
		vtxnorm@.(cnt3 + 2) = dfvec3(2)
	}
	vtxuvec@.cnt3 = 1.0
	vtxuvec@.(cnt3 + 1) = 0.0
	vtxuvec@.(cnt3 + 2) = 0.0

	vtxvvec@.cnt3 = 0.0
	vtxvvec@.(cnt3 + 1) = 0.0
	vtxvvec@.(cnt3 + 2) = 1.0
	loop

	repeat ydiv2 - 2
	cnt3 = cnt * 3 + idxstart
	faceno@.cnt3 = idxstartvtxno
	faceno@.(cnt3 + 1) = cnt + 1 + idxstartvtxno
	faceno@.(cnt3 + 2) = cnt + 2 + idxstartvtxno
	loop

	facenumdraw@ = ydiv2 - 2 + ydiv2
	vtxnumdraw@ = ydiv2 * 3 + ydiv2
	return

#deffunc torusdataset double lrgr,int shade4,int lrgdiv,double smlr,int smldiv
	dtheta = 2.0 * M_PI / lrgdiv
	dphi = 2.0 * M_PI / smldiv
	du2d = 1.0 / lrgdiv
	dv2d = 1.0 / smldiv

	ddim orgpos,lrgdiv,smldiv,3
	ddim orgnorm,lrgdiv,smldiv,3

	repeat smldiv
	orgpos(0,cnt,0) = smlr * cos(dphi * double(cnt)) + lrgr
	orgpos(0,cnt,1) = smlr * sin(dphi * double(cnt))
	orgpos(0,cnt,2) = 0.0

	orgnorm(0,cnt,0) = cos(dphi * double(cnt))
	orgnorm(0,cnt,1) = sin(dphi * double(cnt))
	orgnorm(0,cnt,2) = 0.0
	loop

	dfvec1 = 0.0,1.0,0.0
	repeat lrgdiv - 1,1
	lrgcnt = cnt
	setquaternxyztheta quater4,dfvec1,dtheta * lrgcnt
		repeat smldiv
		dfvec2(0) = orgpos(0,cnt,0)
		dfvec2(1) = orgpos(0,cnt,1)
		dfvec2(2) = orgpos(0,cnt,2)
		quaterniontransform1 dfvec3,quater4,dfvec2
		orgpos(lrgcnt,cnt,0) = dfvec3(0)
		orgpos(lrgcnt,cnt,1) = dfvec3(1)
		orgpos(lrgcnt,cnt,2) = dfvec3(2)

		dfvec2(0) = orgnorm(0,cnt,0)
		dfvec2(1) = orgnorm(0,cnt,1)
		dfvec2(2) = orgnorm(0,cnt,2)
		quaterniontransform1 dfvec3,quater4,dfvec2
		orgnorm(lrgcnt,cnt,0) = dfvec3(0)
		orgnorm(lrgcnt,cnt,1) = dfvec3(1)
		orgnorm(lrgcnt,cnt,2) = dfvec3(2)
		loop
	loop

	repeat lrgdiv * smldiv
	dfi = cnt / smldiv
	dfj = cnt \ smldiv
	dfi1 = dfi + 1
	if dfi1 = lrgdiv : dfi1 = 0
	dfj1 = dfj + 1
	if dfj1 = smldiv : dfj1 = 0
	cnt12 = 12 * cnt
	
	vtxpos@.cnt12 = orgpos(dfi,dfj,0)
	vtxpos@.(cnt12 + 1) = orgpos(dfi,dfj,1)
	vtxpos@.(cnt12 + 2) = orgpos(dfi,dfj,2)
	vtxpos@.(cnt12 + 3) = orgpos(dfi1,dfj,0)
	vtxpos@.(cnt12 + 4) = orgpos(dfi1,dfj,1)
	vtxpos@.(cnt12 + 5) = orgpos(dfi1,dfj,2)
	vtxpos@.(cnt12 + 6) = orgpos(dfi1,dfj1,0)
	vtxpos@.(cnt12 + 7) = orgpos(dfi1,dfj1,1)
	vtxpos@.(cnt12 + 8) = orgpos(dfi1,dfj1,2)
	vtxpos@.(cnt12 + 9) = orgpos(dfi,dfj1,0)
	vtxpos@.(cnt12 + 10) = orgpos(dfi,dfj1,1)
	vtxpos@.(cnt12 + 11) = orgpos(dfi,dfj1,2)

	vtxnorm@.cnt12 = orgnorm(dfi,dfj,0)
	vtxnorm@.(cnt12 + 1) = orgnorm(dfi,dfj,1)
	vtxnorm@.(cnt12 + 2) = orgnorm(dfi,dfj,2)
	vtxnorm@.(cnt12 + 3) = orgnorm(dfi1,dfj,0)
	vtxnorm@.(cnt12 + 4) = orgnorm(dfi1,dfj,1)
	vtxnorm@.(cnt12 + 5) = orgnorm(dfi1,dfj,2)
	vtxnorm@.(cnt12 + 6) = orgnorm(dfi1,dfj1,0)
	vtxnorm@.(cnt12 + 7) = orgnorm(dfi1,dfj1,1)
	vtxnorm@.(cnt12 + 8) = orgnorm(dfi1,dfj1,2)
	vtxnorm@.(cnt12 + 9) = orgnorm(dfi,dfj1,0)
	vtxnorm@.(cnt12 + 10) = orgnorm(dfi,dfj1,1)
	vtxnorm@.(cnt12 + 11) = orgnorm(dfi,dfj1,2)
	if shade4 = 0{
		dfx = vtxnorm@.cnt12 + vtxnorm@.(cnt12 + 3) + vtxnorm@.(cnt12 + 6) + vtxnorm@.(cnt12 + 9)
		dfy = vtxnorm@.(cnt12 + 1) + vtxnorm@.(cnt12 + 4) + vtxnorm@.(cnt12 + 7) + vtxnorm@.(cnt12 + 10)
		dfz = vtxnorm@.(cnt12 + 2) + vtxnorm@.(cnt12 + 5) + vtxnorm@.(cnt12 + 8) + vtxnorm@.(cnt12 + 11)
		dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
		dfx /= dfl
		dfy /= dfl
		dfz /= dfl
		vtxnorm@.cnt12 = dfx
		vtxnorm@.(cnt12 + 1) = dfy
		vtxnorm@.(cnt12 + 2) = dfz
		vtxnorm@.(cnt12 + 3) = dfx
		vtxnorm@.(cnt12 + 4) = dfy
		vtxnorm@.(cnt12 + 5) = dfz
		vtxnorm@.(cnt12 + 6) = dfx
		vtxnorm@.(cnt12 + 7) = dfy
		vtxnorm@.(cnt12 + 8) = dfz
		vtxnorm@.(cnt12 + 9) = dfx
		vtxnorm@.(cnt12 + 10) = dfy
		vtxnorm@.(cnt12 + 11) = dfz
	}
	
	cnt8 = 8 * cnt
	vtxtex@.cnt8 = du2d * double(dfi)
	vtxtex@.(cnt8 + 1) = dv2d * double(dfj)
	vtxtex@.(cnt8 + 2) = du2d * double(dfi + 1)
	vtxtex@.(cnt8 + 3) = dv2d * double(dfj)
	vtxtex@.(cnt8 + 4) = du2d * double(dfi + 1)
	vtxtex@.(cnt8 + 5) = dv2d * double(dfj + 1)
	vtxtex@.(cnt8 + 6) = du2d * double(dfi)
	vtxtex@.(cnt8 + 7) = dv2d * double(dfj + 1)

	dfx = cos(-0.5 * M_PI - (0.5 + double(dfi)) * dtheta)
	dfz = sin(-0.5 * M_PI - (0.5 + double(dfi)) * dtheta)
	vtxuvec@.cnt12 = dfx
	vtxuvec@.(cnt12 + 1) = 0.0
	vtxuvec@.(cnt12 + 2) = dfz
	vtxuvec@.(cnt12 + 3) = dfx
	vtxuvec@.(cnt12 + 4) = 0.0
	vtxuvec@.(cnt12 + 5) = dfz
	vtxuvec@.(cnt12 + 6) = dfx
	vtxuvec@.(cnt12 + 7) = 0.0
	vtxuvec@.(cnt12 + 8) = dfz
	vtxuvec@.(cnt12 + 9) = dfx
	vtxuvec@.(cnt12 + 10) = 0.0
	vtxuvec@.(cnt12 + 11) = dfz

	dfx0 = 0.5 * (vtxpos@.cnt12 + vtxpos@.(cnt12 + 3))
	dfy0 = vtxpos@.(cnt12 + 1)
	dfz0 = 0.5 * (vtxpos@.(cnt12 + 2) + vtxpos@.(cnt12 + 5))
	dfx1 = 0.5 * (vtxpos@.(cnt12 + 6) + vtxpos@.(cnt12 + 9))
	dfy1 = vtxpos@.(cnt12 + 7)
	dfz1 = 0.5 * (vtxpos@.(cnt12 + 8) + vtxpos@.(cnt12 + 11))
	dfx = dfx1 - dfx0
	dfy = dfy1 - dfy0
	dfz = dfz1 - dfz0
	dfl = sqrt(dfx * dfx + dfy * dfy + dfz * dfz)
	dfx /= dfl
	dfy /= dfl
	dfz /= dfl
	vtxvvec@.cnt12 = dfx
	vtxvvec@.(cnt12 + 1) = dfy
	vtxvvec@.(cnt12 + 2) = dfz
	vtxvvec@.(cnt12 + 3) = dfx
	vtxvvec@.(cnt12 + 4) = dfy
	vtxvvec@.(cnt12 + 5) = dfz
	vtxvvec@.(cnt12 + 6) = dfx
	vtxvvec@.(cnt12 + 7) = dfy
	vtxvvec@.(cnt12 + 8) = dfz
	vtxvvec@.(cnt12 + 9) = dfx
	vtxvvec@.(cnt12 + 10) = dfy
	vtxvvec@.(cnt12 + 11) = dfz

	cnt6 = 6 * cnt
	cntvtxidx = cnt * 4
	faceno@.cnt6 = cntvtxidx
	faceno@.(cnt6 + 1) = cntvtxidx + 1
	faceno@.(cnt6 + 2) = cntvtxidx + 3
	faceno@.(cnt6 + 3) = cntvtxidx + 3
	faceno@.(cnt6 + 4) = cntvtxidx + 1
	faceno@.(cnt6 + 5) = cntvtxidx + 2
	loop

	facenumdraw@ = lrgdiv * smldiv * 2
	vtxnumdraw@ = lrgdiv * smldiv * 4

	return
